package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLASTNodeList_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLASTNodeList extends JNIObject  {
	
	/* @generated */
	protected ISLASTNodeList(long ptr) {
		/*** PROTECTED REGION ID(ISLASTNodeList_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLASTNodeList build(long ptr) {
		return new ISLASTNodeList(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLASTNodeList_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_ast_node_list_alloc 
	 * 
	 * @generated
	**/
	 public static ISLASTNodeList build(ISLContext ctx, int n) { 
		/*** PROTECTED REGION ID(static_isl_ast_node_list_alloc) DISABLED START ***/
		ISLASTNodeList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTNodeList.build(ISLNative.isl_ast_node_list_alloc(getNativePtr(ctx), n));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_ast_node_list_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_ast_node_list_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_ast_node_list_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_list_copy 
	 * 
	 * @generated
	**/
	public ISLASTNodeList copy() {
		/*** PROTECTED REGION ID(isl_ast_node_list_copy) DISABLED START ***/
		ISLASTNodeList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTNodeList.build(ISLNative.isl_ast_node_list_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_list_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_ast_node_list_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_ast_node_list_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_list_n_ast_node 
	 * 
	 * @generated
	**/
	public int getNbNodes() {
		/*** PROTECTED REGION ID(isl_ast_node_list_n_ast_node) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_ast_node_list_n_ast_node(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_list_get_ast_node 
	 * 
	 * @generated
	**/
	public ISLASTNode get(int index) {
		/*** PROTECTED REGION ID(isl_ast_node_list_get_ast_node) DISABLED START ***/
		ISLASTNode res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTNode.build(ISLNative.isl_ast_node_list_get_ast_node(getNativePtr(this), index));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_list_set_ast_node 
	 * 
	 * @take this node
	 * @generated
	**/
	public ISLASTNodeList set(int index, ISLASTNode node) {
		/*** PROTECTED REGION ID(isl_ast_node_list_set_ast_node) DISABLED START ***/
		ISLASTNodeList res;
		
		synchronized(LOCK) {
			checkParameters(this, node);
			try {
				res = ISLASTNodeList.build(ISLNative.isl_ast_node_list_set_ast_node(getNativePtr(this), index, getNativePtr(node)));
			} finally {
				taken(this);
				taken(node);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_list_insert 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLASTNodeList insert(int pos, ISLASTNode el) {
		/*** PROTECTED REGION ID(isl_ast_node_list_insert) DISABLED START ***/
		ISLASTNodeList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLASTNodeList.build(ISLNative.isl_ast_node_list_insert(getNativePtr(this), pos, getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_list_add 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLASTNodeList add(ISLASTNode el) {
		/*** PROTECTED REGION ID(isl_ast_node_list_add) DISABLED START ***/
		ISLASTNodeList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLASTNodeList.build(ISLNative.isl_ast_node_list_add(getNativePtr(this), getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_list_drop 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLASTNodeList drop(int first, int n) {
		/*** PROTECTED REGION ID(isl_ast_node_list_drop) DISABLED START ***/
		ISLASTNodeList res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLASTNodeList.build(ISLNative.isl_ast_node_list_drop(getNativePtr(this), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_list_concat 
	 * 
	 * @take this list2
	 * @generated
	**/
	public ISLASTNodeList concat(ISLASTNodeList list2) {
		/*** PROTECTED REGION ID(isl_ast_node_list_concat) DISABLED START ***/
		ISLASTNodeList res;
		
		synchronized(LOCK) {
			checkParameters(this, list2);
			try {
				res = ISLASTNodeList.build(ISLNative.isl_ast_node_list_concat(getNativePtr(this), getNativePtr(list2)));
			} finally {
				taken(this);
				taken(list2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLASTNodeList_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
